"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeTSDocTagDefinition = exports.loadTSDocConfig = exports.loadPackage = void 0;
const tsdoc_config_1 = require("@microsoft/tsdoc-config");
const api_extractor_model_1 = require("@microsoft/api-extractor-model");
function loadPackage(modelPath, model) {
    try {
        return model.loadPackage(modelPath);
    }
    catch (e) {
        throw new Error(`Cannot load package model from ${modelPath}: ${e.message}`);
    }
}
exports.loadPackage = loadPackage;
function loadTSDocConfig(path) {
    const tsdocConfig = tsdoc_config_1.TSDocConfigFile.loadFile(path);
    if (tsdocConfig.hasErrors) {
        throw new Error(tsdocConfig.getErrorSummary());
    }
    return tsdocConfig;
}
exports.loadTSDocConfig = loadTSDocConfig;
function mergeTSDocTagDefinition(definitions) {
    const tsdocConfig = api_extractor_model_1.AedocDefinitions.tsdocConfiguration;
    const customTags = [];
    definitions.forEach(definition => {
        if (tsdocConfig.tryGetTagDefinition(definition.tagName) == null) {
            // @ts-ignore
            tsdocConfig.addTagDefinition(definition);
            customTags.push(definition.tagName);
        }
    });
    return customTags;
}
exports.mergeTSDocTagDefinition = mergeTSDocTagDefinition;
